function plot_SO( acc_est1, acc_est2, acc_est3, acc_est4, omega, omega_dot, acc_body, l1, l2, l3, l4)
%PLOT_SO Plots results in SO

%Lever arm for each IMU from CO in {b}
l1 = [-465, -184, -73];
l2 = [-244, 184, -13];
l3 = [740, 130, 82];
l4 = [450, -160, 82];

%Preallocating variables
a_l = [];

for i = 1:4
    eval(sprintf('l=l%i;',i));
    eval(sprintf('acc=acc_est%i;',i));
    k = 1;
    for j = 1:length(acc_est1(1,:))
        %Finding corresponding Qualisys measurement
        while acc(1,j) > omega(1,k)
            k = k + 1;
        end
        cross = Smtrx(omega(2:4,k))*l';
        a_l(:,j) = acc_body(2:4,k) + Smtrx(omega_dot(2:4,k))*l'+Smtrx(omega(2:4,k))*cross;
    end
    if i == 1 || i==3
        f = figure('Units','centimeters','Position',[0,0,16,18],'PaperPositionMode','auto');
        k = 1;
    else
        hold on
        k = 2;
    end
    h = subplot(3,2,k);plot(acc(1,1:988),acc(5,1:988),'r',acc(1,1:988),a_l(1,1:988),'b');xlim([0, 50]);ylim([-400,400]);
    legend({'Estimated','True'},'Interpreter','latex','FontSize',7,'Location','northwest');...%xlabel('Time [s]');
    if i==1 || i==3
        ylabel('$a_x$ [$mm/s^2$]');
    end
    set(gca, 'TickLabelInterpreter','latex');
    clear title; title(sprintf('IMU\\#%i',i));
    p = get(h,'pos');
    p = p + [-0.025, -0.05, 0.025, 0.05];
    set(h, 'pos', p);
    h = subplot(3,2,k+2);plot(acc(1,1:988),acc(6,1:988),'r',acc(1,1:988),a_l(2,1:988),'b');xlim([0, 50]);ylim([-400,400]);
    legend({'Estimated','True'},'Interpreter','latex','FontSize',7,'Location','northwest');...%xlabel('Time [s]');
    if i==1 || i==3
        ylabel('$a_y$ [$mm/s^2$]');
    end
    set(gca, 'TickLabelInterpreter','latex');
    p = get(h,'pos');
    p = p + [-0.025, -0.05, 0.025, 0.05];
    set(h, 'pos', p);
    h = subplot(3,2,k+4);plot(acc(1,1:988),acc(7,1:988),'r',acc(1,1:988),a_l(3,1:988),'b');xlim([0, 50]);ylim([-500,500]);
    legend({'Estimated','True'},'Interpreter','latex','FontSize',7,'Location','northwest');xlabel('Time [s]');
    if i==1 || i==3
        ylabel('$a_z$ [$mm/s^2$]');
    end
    set(gca, 'TickLabelInterpreter','latex');
    p = get(h,'pos');
    p = p + [-0.025, -0.05, 0.025, 0.05];
    set(h, 'pos', p);
    if i==2
        set(f, 'PaperSize',[16, 18]);
        print(f, 'acc_SO_imu1&2', '-dpdf');
    elseif i==4
        set(f, 'PaperSize',[16, 18]);
        print(f, 'acc_SO_imu3&4', '-dpdf');
end
end