function [ oqus ] = xyz2zyx( oqus )
%XYZTOZYX Transform angles from xyz to zyx
%   Input is measured angles from Qualisys, given with xyz-convention. The
%   function transform these to the zyx-convention, and outputs edited
%   Euler angles
oqus(5:7,:) = deg2rad(oqus(5:7,:));

for i = 1:length(oqus(1,:))
    Rxyz = [1 0 0; 0 cos(oqus(5,i)) -sin(oqus(5,i)); 0 sin(oqus(5,i)) cos(oqus(5,i))]*...
        [cos(oqus(6,i)) 0 sin(oqus(6,i)); 0 1 0; -sin(oqus(6,i)) 0 cos(oqus(6,i))]*...
        [cos(oqus(7,i)) -sin(oqus(7,i)) 0; sin(oqus(7,i)) cos(oqus(7,i)) 0; 0 0 1];
    [oqus(5,i), oqus(6,i), oqus(7,i)] = R2euler(Rxyz);
end
oqus(5:7,:) = rad2deg(oqus(5:7,:));
end